//+------------------------------------------------------------------+
//|                                                        Puria.mq4 |
//|                                            Copyright  2010, AM2 |
//|                                   http://www.crossmaker.narod.ru |
//+------------------------------------------------------------------+
#define MAGICMA  20101022

extern double StopLoss           = 35;
extern double TakeProfit         = 70;
extern double MovingPeriod1      = 5;
extern double MovingPeriod2      = 75;
extern double MovingPeriod3      = 85;
bool BuyOne=true, SellOne=true;

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ma1,ma2,ma3,macd;
   int    res;  
//---- 
   ma1=iMA(NULL,0,MovingPeriod1,0,MODE_EMA,PRICE_CLOSE,1);
   ma2=iMA(NULL,0,MovingPeriod2,0,MODE_LWMA,PRICE_LOW,1);
   ma3=iMA(NULL,0,MovingPeriod3,0,MODE_LWMA,PRICE_LOW,1);
   macd=iMACD(NULL,0,15,26,1,PRICE_CLOSE,MODE_MAIN,1);

//---- buy 
   if(ma1>ma2 && ma1>ma3  && macd>0 && BuyOne)  
     {
      res=OrderSend(Symbol(),OP_BUY,Lots(),Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
      BuyOne=false;
      SellOne=true;
      return;
     }       
//---- sell   
   if(ma1<ma2 && ma1<ma3  && macd<0 && SellOne)  
     {
      res=OrderSend(Symbol(),OP_SELL,Lots(),Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
      SellOne=false;
      BuyOne=true;            
      return;
     }
 
  }  

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   CheckForOpen();
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double Lots()
  {
   double Lots;
   Lots=AccountFreeMargin()/10000*5;
   Lots=MathMin(15,MathMax(0.1,Lots));
   if(Lots<0.1) 
     Lots=NormalizeDouble(Lots,2);
   else
     {
     if(Lots<1) Lots=NormalizeDouble(Lots,1);
     else       Lots=NormalizeDouble(Lots,0);
     }
     return(Lots);
  }
//+------------------------------------------------------------------+  